<?php

/*

Copyright Tom Kiss 2008
www.tomkiss.net
TK Page Title - Control Panel

*/


class Tk_page_title_CP { 


    var $version        = '1.0.8'; 

    // -------------------------
    //  Constructor
    // -------------------------
    
    function Tk_page_title_CP( $switch = TRUE )
    {
        global $IN, $DB;
        
		/** -------------------------------
		/**  Is the module installed?
		/** -------------------------------*/
        
        $query = $DB->query("SELECT COUNT(*) AS count FROM exp_modules WHERE module_name = 'Tk_page_title'");
        
        if ($query->row['count'] == 0)
        {
        	return;
        }
        
        if ($switch)
        {
            switch($IN->GBL('P'))
            {
			     
                 case 'delete'          :	$this->delete_tk_page_title();
                     break;
                 case 'delete_confirm'          :	$this->delete_confirm_tk_page_title();
                     break;
                 case 'modify'          :	$this->modify_tk_page_title();
                     break;
                 case 'add'          :	$this->modify_tk_page_title("new");
                     break;
                 case 'save'          :	$this->save_tk_page_title();
                     break;
                 case 'update'          :	$this->update_tk_page_title();
                     break;
                 case 'clear'          :	$this->clear_tk_page_title();
                     break;
                 default                :	$this->tk_page_title_home();
                     break;

            }
        }
    }
    // END

	
	
	// ----------------------------------------
    //  Delete
    // ----------------------------------------

    function delete_tk_page_title()
    {
	    
		global $IN, $DSP, $LANG, $SESS, $DB;        
        
        if ( ! $IN->GBL('delete', 'POST'))
        {
            return $this->tk_page_title_home();
        }

        $ids = array();
                
        foreach ($_POST as $key => $val)
        {        
            if (strstr($key, 'delete') AND ! is_array($val))
            {
                $ids[] = "tk_page_title_id = '".$DB->escape_str($val)."'";
            }        
        }
        
        $IDS = implode(" OR ", $ids);
        
        $DB->query("DELETE FROM exp_tk_page_title WHERE ".$IDS);
    
        $message = (count($ids) == 1) ? $LANG->line('tk_page_title_deleted') : $LANG->line('tk_page_titles_deleted');


        return $this->tk_page_title_home($message);
	}

	
	
	// ----------------------------------------
    //  Clear cache
    // ----------------------------------------

    function clear_tk_page_title()
    {
	    
		global $IN, $DSP, $LANG, $SESS, $DB;        
		
		$message = "";
		
		// Get all page title types
        $query = $DB->query("SELECT tk_page_title_storelocation FROM exp_tk_page_title");
		$delcount = 0;
		if ($query->num_rows > 0) {
			foreach($query->row as $name => $pref) {
				$this->{$name} = $pref;
				// Get store location and delete all png files inside that location
				$dir = $_SERVER['DOCUMENT_ROOT'].$query->row['tk_page_title_storelocation'];
				if (is_dir($dir)) {
					if ($handle = opendir($dir)) {
						while (false !== ($file = readdir($handle))) { 
							if (substr($file, -3) == "png") {  
								unlink($dir.$file);
								$delcount++;
							}
						}
						closedir($handle); 
					} else {
						$message = 	$LANG->line('tk_page_title_opendirfail');
					}
				} else {
					$message = 	$LANG->line('tk_page_title_nodir');
				}
			}
		} else {
			$message = 	$LANG->line('tk_page_title_noresults');
		}
		if ($message == "") {
			$message = ($delcount != 1 ? $delcount.$LANG->line('tk_page_title_delfiles') : $delcount.$LANG->line('tk_page_title_delfile'));
		}
		// Display result of attempt to clear cache
        return $this->tk_page_title_home($message);
	}


	/** -------------------------------------------
    /**  Save 
    /** -------------------------------------------*/

    function save_tk_page_title()
    {
    	global $IN, $DSP, $LANG, $DB, $OUT;
		
		$required	= array('tk_page_title_name', 'tk_page_title_width', 'tk_page_title_fontsize', 'tk_page_title_htmltag', 'tk_page_title_fontfile', 'tk_page_title_fontcol');
    	
    	$data	= array();
    	$errors	= array();
		
		// Check through POST data
    	foreach($required as $var) {
    		if ( ! isset($_POST[$var]) OR $_POST[$var] == '') {
    			return $OUT->show_user_error('submission', $LANG->line('tk_page_title_missing_fields'));
    		}
    		$data[$var] = $_POST[$var];
    	}
		$data['tk_page_title_gradientfile'] = $_POST['tk_page_title_gradientfile'];
		$data['tk_page_title_storelocation'] = $_POST['tk_page_title_storelocation'];
		
		// Error checking
    	if (isset($data['tk_page_title_gradientfile']) && $data['tk_page_title_gradientfile'] != '') {
			if (is_dir($_SERVER['DOCUMENT_ROOT'].$data['tk_page_title_gradientfile'])) {
				$errors[] = $LANG->line('tk_page_title_gradient_not_found');
			}
			if (!file_exists($_SERVER['DOCUMENT_ROOT'].$data['tk_page_title_gradientfile'])) {
				$errors[] = $LANG->line('tk_page_title_gradient_not_found');
			}
		}
		if (is_dir($data['tk_page_title_fontfile'])) {
			$errors[] = $LANG->line('tk_page_title_fontfile_not_found');
		}
		if (!file_exists($data['tk_page_title_fontfile'])) {
			$errors[] = $LANG->line('tk_page_title_fontfile_not_found');
		}
		if (!file_exists($_SERVER['DOCUMENT_ROOT'].$data['tk_page_title_storelocation'])) {
			$errors[] = $LANG->line('tk_page_title_store_not_exist');
		}
		if (!is_writable($_SERVER['DOCUMENT_ROOT'].$data['tk_page_title_storelocation'])) {
			$errors[] = $LANG->line('tk_page_title_store_not_writable');
		}
		
		// Output any errors
		if (sizeof($errors) > 0) {
			return $OUT->show_user_error('submission', $errors);
		}
	
		// Post new data
		if ($_POST['tk_page_title_id'] == 'new') {
			$data['tk_page_title_id'] = '';    		
			$DB->query($DB->insert_string('exp_tk_page_title', $data));
			$message = $LANG->line('tk_page_title_saved');
		} else {    		
			$DB->query($DB->update_string('exp_tk_page_title', $data, "tk_page_title_id = '".$DB->escape_str($_POST['tk_page_title_id'])."'"));
			$message = $LANG->line('tk_page_title_saved');
		}
		
		// Redirect on success
		return $this->tk_page_title_home($message);
    
	}	
	
	// ----------------------------------------
    //  Delete confirm
    // ----------------------------------------

    function delete_confirm_tk_page_title()
    { 
        global $IN, $DSP, $LANG;
        
        if ( ! $IN->GBL('toggle', 'POST'))
        {
            return $this->tk_page_title_home();
        }
        
        $DSP->title = $LANG->line('tk_page_title_name');
        $DSP->crumb = $DSP->anchor(BASE.AMP.'C=modules'.AMP.'M=tk_page_title', $LANG->line('tk_page_title_name'));
		$DSP->crumb .= $DSP->crumb_item($LANG->line('delete'));

        $DSP->body	.=	$DSP->form_open(array('action' => 'C=modules'.AMP.'M=tk_page_title'.AMP.'P=delete'));
        
        $i = 0;
        
        foreach ($_POST as $key => $val)
        {        
            if (strstr($key, 'toggle') AND ! is_array($val))
            {
                $DSP->body	.=	$DSP->input_hidden('delete[]', $val);
                
                $i++;
            }        
        }
        
		$DSP->body .= $DSP->heading($DSP->qspan('alert', $LANG->line('tk_page_title_delete_confirm')));
		$DSP->body .= $DSP->div('box');
		$DSP->body .= $DSP->qdiv('defaultBold', $LANG->line('tk_page_title_delete_question'));
		$DSP->body .= $DSP->qdiv('alert', BR.$LANG->line('action_can_not_be_undone'));
		$DSP->body .= $DSP->qdiv('', BR.$DSP->input_submit($LANG->line('delete')));
		$DSP->body .= $DSP->qdiv('alert',$DSP->div_c());
		$DSP->body .= $DSP->div_c();
		$DSP->body .= $DSP->form_close();
    
	}
	
	
	// ----------------------------------------
    //  Modify
    // ----------------------------------------

    function modify_tk_page_title($id = '')
    {
	        global $IN, $DSP, $LANG, $DB, $SESS, $PREFS;           
        
        $id = ( ! $IN->GBL('id', 'GET')) ? $id : $IN->GBL('id');
        
        if ($id == '')
        {
            return $this->tk_page_title_home();
        }
        
        /** ----------------------------
        /**  Form Values
        /** ----------------------------*/
        
		$tk_page_title_id = '';
		$tk_page_title_name = '';
		$tk_page_title_width = '';
		$tk_page_title_fontsize = '24';
		$tk_page_title_fontfile = $_SERVER['DOCUMENT_ROOT'].'/themes/tk_page_title/fonts/';
		$tk_page_title_gradientfile = '/themes/tk_page_title/gradients/';
		$tk_page_title_fontcol = '000000';
		$tk_page_title_htmltag = 'h1';
		$tk_page_title_storelocation = '/themes/tk_page_title/pagetitles/';
        
        if ($id != 'new')
        {
        	$query = $DB->query("SELECT * FROM exp_tk_page_title WHERE tk_page_title_id = '".$DB->escape_str($id)."'");
        	
        	if ($query->num_rows == 0)
        	{
           		return $this->tk_page_title_home();
        	}
        	
        	foreach($query->row as $name => $pref)
        	{
        		${$name} = $pref;
			}	
        }
		
                
        $DSP->title  = $LANG->line('tk_page_title_name');
        $DSP->crumb  = $DSP->anchor(BASE.AMP.'C=modules'.AMP.'M=tk_page_title', $LANG->line('tk_page_title_module_name'));
		$DSP->crumb  .= $DSP->crumb_item(($id == 'new') ? $LANG->line('tk_page_title_new') : $LANG->line('tk_page_title_edit'));
		
		$DSP->body .= ($id == 'new') ? $DSP->qdiv('tableHeading', $LANG->line('tk_page_title_new')) : $DSP->qdiv('tableHeading', $LANG->line('tk_page_title_edit'));
		
        $DSP->body .=	$DSP->form_open(
        								array(
        										'action' => 'C=modules'.AMP.'M=tk_page_title'.AMP.'P=save', 
        										'name'	=> 'configuration',
        										'id' 	=> 'configuration'
        									),
        								array('tk_page_title_id' => $id)
        								);
            	
    	/** ---------------------------
    	/**  Begin Creating Form
    	/** ---------------------------*/
    	
    	$LANG->fetch_language_file('publish');
    	
				
		$r =	$DSP->table('tableBorder', '0', '', '100%');
		$r .=	$DSP->tr();
		$r .=   $DSP->td('tableHeadingAlt', '', '2');
		$r .=   $LANG->line('tk_page_title_options');
		$r .=   $DSP->td_c();
		$r .=	$DSP->tr_c();
		
		$i = 0;
		$style = ($i % 2) ? 'tableCellOne' : 'tableCellTwo';
		
		// tk_page_title_name
		$r .= $DSP->td($style, '50%', '');
		$r .= $DSP->div('defaultBold');
		$r .= $LANG->line('tk_page_title_name', 'tk_page_title_name');
		$r .= $DSP->div_c();
    	$r .= $DSP->td_c();
    	
    	$r .= $DSP->td($style, '50%', '');
		if ($tk_page_title_name == "Default") {
    		$r .= $DSP->input_hidden('tk_page_title_name', $tk_page_title_name).$tk_page_title_name;
		} else {
    		$r .= $DSP->input_text('tk_page_title_name', $tk_page_title_name, '20', '120', 'input', '50%');
		}
		
    	$r .= $DSP->td_c();
		$r .= $DSP->tr_c();
		
		$i++;
		$style = ($i % 2) ? 'tableCellOne' : 'tableCellTwo';

		// tk_page_title_width
		$r .= $DSP->td($style, '50%', '');
		$r .= $DSP->div('defaultBold');
		$r .= $LANG->line('tk_page_title_width_long', 'tk_page_title_width_long');
		$r .= $DSP->div_c();
    	$r .= $DSP->td_c();
    	
    	$r .= $DSP->td($style, '50%', '');
    	$r .= $DSP->input_text('tk_page_title_width', $tk_page_title_width, '20', '20', 'input', '20%');
    	$r .= $DSP->td_c();
		$r .= $DSP->tr_c();
		
		$i++;
		$style = ($i % 2) ? 'tableCellOne' : 'tableCellTwo';
		
		// tk_page_title_fontsize
		$r .= $DSP->td($style, '50%', '');
		$r .= $DSP->div('defaultBold');
		$r .= $LANG->line('tk_page_title_fontsize_long', 'tk_page_title_fontsize_long');
		$r .= $DSP->div_c();
    	$r .= $DSP->td_c();
    	
    	$r .= $DSP->td($style, '50%', '');
    	$r .= $DSP->input_text('tk_page_title_fontsize', $tk_page_title_fontsize, '20', '20', 'input', '20%');
    	$r .= $DSP->td_c();
		$r .= $DSP->tr_c();
		
		$i++;
		$style = ($i % 2) ? 'tableCellOne' : 'tableCellTwo';
		
		// tk_page_title_htmltag
		$r .= $DSP->td($style, '50%', '');
		$r .= $DSP->div('defaultBold');
		$r .= $LANG->line('tk_page_title_htmltag', 'tk_page_title_htmltag');
		$r .= $DSP->div_c();
    	$r .= $DSP->td_c();
    	
    	$r .= $DSP->td($style, '50%', '');
    	$r .= $DSP->input_text('tk_page_title_htmltag', $tk_page_title_htmltag, '20', '120', 'input', '20%');
    	$r .= $DSP->td_c();
		$r .= $DSP->tr_c();
		
		$i++;
		$style = ($i % 2) ? 'tableCellOne' : 'tableCellTwo';
		
		// tk_page_title_fontcol
		$r .= $DSP->td($style, '50%', '');
		$r .= $DSP->div('defaultBold');
		$r .= $LANG->line('tk_page_title_fontcol', 'tk_page_title_fontcol');
		$r .= $DSP->div_c();
    	$r .= $DSP->td_c();
    	
    	$r .= $DSP->td($style, '50%', '');
    	$r .= $DSP->input_text('tk_page_title_fontcol', $tk_page_title_fontcol, '20', '6', 'input', '12%').'<span style="float: left; display: block;">#</span>';
    	$r .= $DSP->td_c();
		$r .= $DSP->tr_c();
		
		$i++;
		$style = ($i % 2) ? 'tableCellOne' : 'tableCellTwo';
		$r .= $DSP->tr_c();
		
		// tk_page_title_fontfile
		$r .= $DSP->td($style, '50%', '');
		$r .= $DSP->div('defaultBold');
		$r .= $LANG->line('tk_page_title_fontfile_long', 'tk_page_title_fontfile_long');
		$r .= $DSP->div_c();
    	$r .= $DSP->td_c();
    	
    	$r .= $DSP->td($style, '50%', '');
    	$r .= $DSP->input_text('tk_page_title_fontfile', $tk_page_title_fontfile, '20', '240', 'input', '100%');
    	$r .= $DSP->td_c();
		
		$i++;
		$style = ($i % 2) ? 'tableCellOne' : 'tableCellTwo';
		$r .= $DSP->tr_c();
		
		// tk_page_title_gradientfile
		$r .= $DSP->td($style, '50%', '');
		$r .= $DSP->div('defaultBold');
		$r .= $LANG->line('tk_page_title_gradientfile_long', 'tk_page_title_gradientfile_long');
		$r .= $DSP->div_c();
    	$r .= $DSP->td_c();
    	
    	$r .= $DSP->td($style, '50%', '');
    	$r .= $DSP->input_text('tk_page_title_gradientfile', $tk_page_title_gradientfile, '20', '240', 'input', '100%');
    	$r .= $DSP->td_c();
		$r .= $DSP->tr_c();
		
		$i++;
		$style = ($i % 2) ? 'tableCellOne' : 'tableCellTwo';
		$r .= $DSP->tr_c();
		
		// tk_page_title_storelocation
		$r .= $DSP->td($style, '50%', '');
		$r .= $DSP->div('defaultBold');
		$r .= $LANG->line('tk_page_title_storelocation_long', 'tk_page_title_storelocation_long');
		$r .= $DSP->div_c();
    	$r .= $DSP->td_c();
    	
    	$r .= $DSP->td($style, '50%', '');
    	$r .= $DSP->input_text('tk_page_title_storelocation', $tk_page_title_storelocation, '20', '240', 'input', '100%');
    	$r .= $DSP->td_c();
		$r .= $DSP->tr_c();
		
		$i++;
		$style = ($i % 2) ? 'tableCellOne' : 'tableCellTwo';
		
		// update
		$r .= $DSP->td($style, '50%', '');
		$r .= "";
    	$r .= $DSP->td_c();
    	
    	$r .= $DSP->td($style, '50%', '');
    	$r .= $DSP->qdiv('itemWrapperTop', $DSP->input_submit(($id == 'new') ? $LANG->line('submit') : $LANG->line('update')));
    	$r .= $DSP->td_c();
		$r .= $DSP->tr_c();
		
		$r .= $DSP->table_c();
        
		$DSP->body .= $r.$DSP->form_close();       
	}
	
	
		
	// ----------------------------------------
    //  Update
    // ----------------------------------------

    function update_tk_page_title()
    {
	
	}
	
	
	// ----------------------------------------
    //  Module Homepage
    // ----------------------------------------

    function tk_page_title_home($msg = '')
    {
	
		global $DSP, $LANG, $PREFS, $FNS, $DB;
                        
        $DSP->title  = $LANG->line('tk_page_title_module_name');
        $DSP->crumb  = $LANG->line('tk_page_title_module_name');
        
		$DSP->right_crumb($LANG->line('tk_page_title_create_new'), BASE.AMP.'C=modules'.AMP.'M=tk_page_title'.AMP.'P=add');
        
        $DSP->body .= $DSP->qdiv('tableHeading', $LANG->line('tk_page_title_types')); 
        
        if ($msg != '')
        {
			$DSP->body .= $DSP->qdiv('successBox', $DSP->qdiv('success', $msg));
        }
		
        $query = $DB->query("SELECT tk_page_title_name, tk_page_title_id, tk_page_title_width, tk_page_title_fontsize, tk_page_title_fontfile, tk_page_title_gradientfile, tk_page_title_fontcol, tk_page_title_storelocation, tk_page_title_htmltag FROM exp_tk_page_title");
        
        $DSP->body	.=	$DSP->toggle();
                
        $DSP->body	.=	$DSP->form_open(array('action' => 'C=modules'.AMP.'M=tk_page_title'.AMP.'P=delete_confirm', 'name' => 'target', 'id' => 'target'));
    
	
        $DSP->body	.=	$DSP->table('tableBorder', '0', '0', '100%').
						$DSP->tr().
						$DSP->table_qcell('tableHeadingAlt', 
											array(
													$LANG->line('tk_page_title_name'),
													$LANG->line('tk_page_title_width'),
													$LANG->line('tk_page_title_fontsize'),
													$LANG->line('tk_page_title_htmltag'),
													$LANG->line('tk_page_title_fontcol'),
													$LANG->line('tk_page_title_locations'),
													''.NBS.NBS
												 )
											).
						$DSP->tr_c();
		
		$i = 0;

		foreach ($query->result as $row)
		{				
			$style = ($i++ % 2) ? 'tableCellOne' : 'tableCellTwo';
                      
            $DSP->body .= $DSP->tr();
            
            	$namelink = $DSP->qdiv('defaultBold',
											$DSP->anchor(BASE.AMP.'C=modules'.
											AMP.'M=tk_page_title'.
											AMP.'P=modify'.
											AMP.'id='.$row['tk_page_title_id'],
											$row['tk_page_title_name']));
						
				$DSP->body .= $DSP->table_qcell($style, 
									array(
											$namelink,
											$row['tk_page_title_width'],
											$row['tk_page_title_fontsize'],
											$row['tk_page_title_htmltag'],
											'<span style="float: left; padding-right: 6px">#'.$row['tk_page_title_fontcol'].'</span><span title="#'.$row['tk_page_title_fontcol'].'" style="float: left; width: 12px; height: 12px; background-color: #'.$row['tk_page_title_fontcol'].'; border: 1px solid black; display: block; font-size:0px; ">&nbsp;</span>',
											'<span style="font-size: smaller">'.$LANG->line('tk_page_title_fontfile').': '.$row['tk_page_title_fontfile'].'</span><br/>
											<span style="font-size: smaller">'.$LANG->line('tk_page_title_gradientfile').': '.$row['tk_page_title_gradientfile'].'</span><br/>
											<span style="font-size: smaller">'.$LANG->line('tk_page_title_storelocation').': '.$row['tk_page_title_storelocation'].'</span>',
											$DSP->input_checkbox('toggle[]', $row['tk_page_title_id'], '', ($row['tk_page_title_name'] == "Default" ? 'disabled' : ''))
										 )
									).
				$DSP->tr_c();
				$DSP->body .= $DSP->table_row(array(
									array(
											'text'		=> $DSP->div('defaultLight').
'{exp:tk_page_title type="'.$row['tk_page_title_name'].'"}Your text here{/exp:tk_page_title}'.$DSP->div_c(),
											'class'		=> $style,
											'colspan'	=> '7'
										)
									)
								);
					
				require_once 'mod.tk_page_title.php';
				
				$TMPL = array();
				$TMPL["tagdata"] = array("");
				//global $TMPL;
				
				//new TK_Page_Title();	
				//$img = $TK_Page_Title->TK_Page_Title();
				
				$DSP->body .= $DSP->tr_c();
		}
		
		
		
		
		$style = ($i++ % 2) ? 'tableCellOne' : 'tableCellTwo';
		$DSP->body .= $DSP->table_row(array(
									array(
											'text'		=> $DSP->anchor('http://www.tomkiss.net/ee/add-on/tk_page_title', $LANG->line('tk_page_title_documentation'))." | ".$DSP->anchor(BASE.AMP.'C=modules'.AMP.'M=tk_page_title'.AMP.'P=clear', $LANG->line('tk_page_title_clear')),
											'class'		=> $style,
											'colspan'	=> '6'
										),
		
									array(
											'text'		=> $DSP->qdiv('itemWrapper', $DSP->input_submit($LANG->line('delete'))),
											'class'		=> $style,
											'colspan'	=> '1'
										)
									)
								);
		
        $DSP->body	.=	$DSP->table_close(); 
        $DSP->body	.=	$DSP->form_close();  
		
		/*
        $DSP->body	.=	$DSP->table_c(); 
    	
		$DSP->body	.=	$DSP->qdiv('itemWrapperTop', $DSP->input_submit($LANG->line('delete')));             
        
        $DSP->body	.=	$DSP->form_close();     
		*/
		
	}


    // ----------------------------------------
    //  Module installer
    // ----------------------------------------

    function tk_page_title_module_install()
    {
        global $DB;        
        
        $sql[] = "INSERT INTO exp_modules (module_id, 
                                           module_name, 
                                           module_version, 
                                           has_cp_backend) 
                                           VALUES 
                                           ('', 
                                           'Tk_page_title', 
                                           '$this->version', 
                                           'y')";
                                           

        $sql[] = "CREATE TABLE IF NOT EXISTS `exp_tk_page_title` (
                 `tk_page_title_id` INT(6) UNSIGNED NOT NULL AUTO_INCREMENT,
                 `tk_page_title_name` TEXT NOT NULL ,
                 `tk_page_title_width` INT(6) ,
                 `tk_page_title_fontsize` INT(6) ,
                 `tk_page_title_fontfile` TEXT NOT NULL ,
                 `tk_page_title_gradientfile` TEXT NOT NULL ,
                 `tk_page_title_fontcol` TEXT NOT NULL ,
                 `tk_page_title_htmltag` TEXT NOT NULL ,
                 `tk_page_title_storelocation` TEXT NOT NULL ,
                 PRIMARY KEY (`tk_page_title_id`));";
    
 		$sql[] = "INSERT INTO exp_tk_page_title (tk_page_title_id, tk_page_title_name, tk_page_title_width, tk_page_title_fontsize, tk_page_title_fontfile, tk_page_title_gradientfile, tk_page_title_fontcol, tk_page_title_htmltag, tk_page_title_storelocation) VALUES ('', 'Default', 600, 24, '".$_SERVER['DOCUMENT_ROOT']."/themes/tk_page_title/fonts/verdana.ttf', '/themes/tk_page_title/gradients/default.png', '000000', 'h1', '/themes/tk_page_title/pagetitles/')";
		
        foreach ($sql as $query)
        {
            $DB->query($query);
        }
        
        return true;
    }
    // END
	
	
	// ----------------------------------------
    //  Module de-installer
    // ----------------------------------------

    function tk_page_title_module_deinstall()
    {
        global $DB;    

        $query = $DB->query("SELECT module_id
                             FROM exp_modules 
                             WHERE module_name = 'Tk_page_title'"); 
                
        $sql[] = "DELETE FROM exp_module_member_groups 
                  WHERE module_id = '".$query->row['module_id']."'";      
                  
        $sql[] = "DELETE FROM exp_modules 
                  WHERE module_name = 'Tk_page_title'";
                  
        $sql[] = "DELETE FROM exp_actions 
                  WHERE class = 'Tk_page_title'";
                  
        $sql[] = "DELETE FROM exp_actions 
                  WHERE class = 'Tk_page_title_CP'";
                  
        $sql[] = "DROP TABLE IF EXISTS exp_tk_page_title";

        foreach ($sql as $query)
        {
            $DB->query($query);
        }

        return true;
    }
    // END



} 
// END CLASS 

?>