<?php

/*

Copyright Tom Kiss 2008
www.tomkiss.net
TK Page Title

*/

require_once 'incs/class.imagemask.php'; // Image Mask class Copyright Andrew Collington, 2004 - http://php.amnuts.com/
require_once 'incs/package.fig.php'; // Font tools class Copyright Matsuda Shota 2006  - http://sgssweb.com/

class TK_Page_Title {

    var $return_data	= ''; 

    // -------------------------------------
    //  Constructor
    // -------------------------------------

    function TK_Page_Title()
    {
	
		global $TMPL, $DB;
		
		$text = $TMPL->tagdata;
		// Replace any EE variables in this string
		$text = $this->replace_global_variables($text);
		
		// General settings
		$this->storelocation = '/themes/tk_page_title/pagetitles/';
		
		// HTML settings
    	$this->linker = (!$TMPL->fetch_param('link') ? '' : $TMPL->fetch_param('link'));
    	$this->target = (!$TMPL->fetch_param('target') ? '' : ' target="'.$TMPL->fetch_param('target').'"');
    	$this->type = (!$TMPL->fetch_param('type') ? 'main' : strtolower($TMPL->fetch_param('type')));
    	$this->id = (!$TMPL->fetch_param('id') ? '' : ' id="'.$TMPL->fetch_param('id').'"');
    	$this->classy = (!$TMPL->fetch_param('class') ? ' class="pagetitle"' : ' class="pagetitle '.$TMPL->fetch_param('class').'"');
    	$this->onclick = (!$TMPL->fetch_param('onclick') ? '' : ' onclick="'.$TMPL->fetch_param('onclick').'"'); 
    	$this->style = (!$TMPL->fetch_param('style') ? '' : '; '.$TMPL->fetch_param('style')); 
    	$this->align = ($TMPL->fetch_param('align') && ($TMPL->fetch_param('align') == "right" || $TMPL->fetch_param('align') == "center" || $TMPL->fetch_param('align') == "left-adjust" || $TMPL->fetch_param('align') == "center-adjust" || $TMPL->fetch_param('align') == "right-adjust" || $TMPL->fetch_param('align') == "adjust") ? $TMPL->fetch_param('align') : 'left'); 
		
		// Text settings
    	$this->antialias = (($TMPL->fetch_param('antialias') == "false") ? 1 : 4);
    	$this->casey = (!$TMPL->fetch_param('case') ? false : $TMPL->fetch_param('case'));
		if ($this->casey == "upper") {
			$text = mb_strtoupper($text, "utf-8");
		} else if ($this->casey == "title") {
			$text = $this->titleCase($text);
		}
		
		// Debug settings (if set to true, prevents images from caching)
    	$this->debug = (!$TMPL->fetch_param('debug') ? false : true); 
		$this->bugreport = '';
		
		// Get the predefined preferences for this type of image
        $query = $DB->query("SELECT * FROM exp_tk_page_title WHERE tk_page_title_name = '".$this->type."'");
		if ($query->num_rows == 0) {
       		$query = $DB->query("SELECT * FROM exp_tk_page_title WHERE tk_page_title_name = 'Default'");
		} 
		foreach($query->row as $name => $pref) {
        	$this->{$name} = $pref;
        }
		// Predefined preferences
		$this->storelocation = ($this->tk_page_title_storelocation ? $this->tk_page_title_storelocation : $this->storelocation);
		$this->fontfile = $this->tk_page_title_fontfile;
	 	$this->gradientfile = $_SERVER['DOCUMENT_ROOT'].(!$TMPL->fetch_param('gradient') ? $this->tk_page_title_gradientfile : html_entity_decode(strtolower($TMPL->fetch_param('gradient'))));
	 	$this->tag = (!$TMPL->fetch_param('tag') ? $this->tk_page_title_htmltag : strtolower($TMPL->fetch_param('tag')));
	 	$this->width = (!$TMPL->fetch_param('width') ? $this->tk_page_title_width : strtolower($TMPL->fetch_param('width')));
	 	$this->fsize = (!$TMPL->fetch_param('fsize') ? $this->tk_page_title_fontsize : strtolower($TMPL->fetch_param('fsize')));
	 	$this->color = (!$TMPL->fetch_param('color') ? $this->tk_page_title_fontcol : strtolower($TMPL->fetch_param('color')));
		
		// Check store location is writable and output
		if (!empty($text) && is_writable($_SERVER['DOCUMENT_ROOT'].$this->storelocation)) {
			// Get image information
			$imagedata = $this->savePagetitleImage($text);
			$imghtml = ' style="display:block; background-repeat: no-repeat; background-image: url('.$imagedata[0].'); height: '.$imagedata[1].'px; width: '.$this->width.'px'.$this->style.'"';
			// Format link
			if (!empty($this->linker)) {
				$linky = array('<a href="'.$this->linker.'" '.$this->target.$imghtml.' '.$this->onclick.'>', '</a>');
				$imghtml = "";
			} else {
				$linky = array('', '');
			}
			// Format text as HTML
			$text = htmlentities($text, ENT_QUOTES,'UTF-8');
			
			// Create HTML, based on type
			$output = '<'.$this->tag.$imghtml.$this->id.$this->classy.' title="'.$text.'">'.$linky[0].'<span style="display: none">'.$text.'</span>'.$linky[1].'</'.$this->tag.'>'.$this->bugreport;
			$this->return_data = $output;
			
		}
		
	}
	
	// Saves the image to the server
	function savePagetitleImage($string) {
		global $TMPL;
		
		/*
		**********************************
			
		To create the title image, we will need to create and save up to 3 seperate images.
		Firstly, there is a 'mask image' - this will mask the...
		...Second image, which is the 'gradient image' - which has the gradient we want to apply to our text
		And lastly, there is the final image which we want to output.
		
		Lets set up the filenames for each image...
		
		**********************************
		*/

		// Apply any formatting we want to the text string we are placing in the image
		$string = $this->doTheThing($string);
				
		$filename = strtolower(str_replace(" ", "", $string));
		$nocacher = ($this->debug ? rand(0, 10000) : ''); // Prevent caching if  debug is set to true
		$fnameref = md5($filename.$this->gradientfile.$this->fontfile.$this->width.$this->fsize.$this->align.$this->antialias.$nocacher);
		$filename = $this->storelocation.$fnameref.'.png'; // Final image output filename
		$maskfilename = $this->storelocation.$fnameref.'_mask.png'; // Mask image filename
		$gradientfilename = $this->storelocation.$fnameref.'_gradient.png'; // Gradient image filename
		
		
		// Check to see if this image exists, if it does not, then create it
		if (!file_exists($_SERVER['DOCUMENT_ROOT'].$filename)) {
		
			// Pull in settings from the global ones in to this function
			$gradientfile = $this->gradientfile;
			$fontfile = $this->fontfile;
			$width = $this->width;		
			$fsize = $this->fsize;
			
			// General settings - DONT CHANGE THESE
			$maskfontcolour = "000000"; // For the mask image
			$maskbackcolour = "FFFFFF"; // For the mask image
			
			// Calculate the number of lines that will be in the outputted image...
				
			// Array of words in string
			$calc_string = $string;
			// If this is UTF-8, we need to convert it in order to count lines accurately
			if (mb_detect_encoding($calc_string) == "UTF-8") {
				$calc_string = $this->utf2ascii($calc_string);
			}
			$calc_arr = split(" ", $calc_string);
			$calc_str = "";
			$calc_lines = 1;
			$calc_height = 0;


			if (sizeof($calc_arr) > 1) {
				for ($i=0; $i<sizeof($calc_arr); $i++) {
					if ($i < (sizeof($calc_arr))) {
						$calc_str .= ($i > 0 ? " " : "").$calc_arr[$i];
					}
					$calc_imgsize = imagettfbbox($fsize, 0, $fontfile, $calc_str);
					$calc_width = abs($calc_imgsize[4]-$calc_imgsize[6]);
					// Is this word / current string long enough to break a new line?
					if ($calc_width > $width) {
						$calc_height += abs($calc_imgsize[7]);
						// We've gone over the size, let's remove the last word we placed there and start a new line
						$calc_str = str_replace(" ".$calc_arr[$i], "", $calc_str);
						$calc_str = " ".$calc_arr[$i];
						// Start a new line, add next string
						$calc_lines++;
					}
				}
			}
										
			$lines = $calc_lines;

			// BUG FIX 1 - part A
			// If the string is just 1 word, the fig font class we use for real anti aliased text does not make the image. Gah!
			// This rather hap-dash fix over-extends the image on to a new line, then hides it in the outputted image.
			if (strpos($string, " ") == 0) {	
				$bug1 = true;
				$string .= "\n.";
				$lines = 1;
			}
		
									
			/*
			****************************
			
			MASK IMAGE (contains the text)
			
			Create real anti aliased text to use as an alpha-mask
			
			****************************
			*/
			
			$pluggableSet = new DefaultFontImagePluggableSet();
			$pluggableSet->defaultVariables = array(
				"text" => $string,
				"size" => $fsize,
				"font" => $fontfile,
				"color" => "0x000000",
				"alpha" => "100",
				"leading" => $fsize+2,
				"padding" => 0,
				"width" => $width,
				"height" => null,
				"align" => $this->align,
				"valign" => "middle",
				"bgcolor" => "0xffffff",
				"bgtrans" => "false",
				"blank" => false,
				"bgimage" => null,
				"antialias" => $this->antialias,
				"type" => "png",
				"palette" => null,
				"quality" => 100,
				"file" => $_SERVER['DOCUMENT_ROOT'].$maskfilename
			);
			$fig = new FontImageGenerator();
			$fig->setPluggableSet($pluggableSet);
			$fig->execute();
						
			list($maskwidth, $maskheight) = getimagesize($_SERVER['DOCUMENT_ROOT'].$maskfilename);
						
			// BUG FIX 1 - part B
			// continued
			if ($bug1) {	
				$maskheight = ($maskheight/2);
			}
			
			$imageheight = $maskheight;	
			if ($this->debug) {
				$this->bugreport .= "String: ".$string.", Font size: ".$fsize.", Width: ".$width.", Image height: ".$imageheight.", Lines: ".$lines.", Textbox height: ".$textboxheight."<br/>";
			}
				
				
			/*
			
			GRADIENT IMAGE
			
			*/
			
			// Create our blank image to paste the gradient in to
			$imgradient = imagecreatetruecolor($width,$imageheight);
			// Are we making a gradient-filled image?
			$gradientimg = imagecreatefrompng($gradientfile);
			if ($gradientfile != "" && file_exists($gradientfile)) {
				// Load in the gradient we're using for this image
				// Get its properties				
				list($gradientwidth, $gradientheight) = getimagesize($gradientfile);
				// Paste the image in to the new image the same number of times that there are lines
				for ($i=0; $i<$lines; $i++) {
					// Calculate distance to move the line of text down
					$dist = ($maskheight/$lines)*$i;
					imagecopyresized($imgradient, $gradientimg, 0, $dist, 0, 0, $maskwidth, ($maskheight/$lines), $gradientwidth, $gradientheight); // Output gradient across remaining lines
				}
			} else {
				// If we're not making a gradient fill image then fill with our colour	
				$rgb = $this->hex2rgb($this->color);
				$fillcol = imagecolorallocate($imgradient, $rgb[0], $rgb[1], $rgb[2]);
				imagefill($imgradient, 0, 0, $fillcol);
			}
			// Save this image
			imagepng($imgradient, $_SERVER['DOCUMENT_ROOT'].$gradientfilename);
		
		
		
			
			/*
			
			FINAL IMAGE
			
			*/
			
			// Create and save the final image - this requires the imageMask class which is required() at the top of this file
			
			// Check files exist
			if (file_exists($_SERVER['DOCUMENT_ROOT'].$gradientfilename) && file_exists($_SERVER['DOCUMENT_ROOT'].$maskfilename)) {
				
				$masker = new imageMask();
				$masker->setDebugging($this->debug); // Copy current debug pref in to imageMask class
				$masker->maskOption();
				if ($masker->loadImage($_SERVER['DOCUMENT_ROOT'].$gradientfilename)) { // Load the gradient
					if ($masker->applyMask($_SERVER['DOCUMENT_ROOT'].$maskfilename)) { // Apply the mask
						$masker->saveImage($_SERVER['DOCUMENT_ROOT'].$filename); // Save the file
					}
				}
			}
			
			
		} else {
			
			// If our final image is already made, delete the mask and gradient files:
			if (file_exists($_SERVER['DOCUMENT_ROOT'].$gradientfilename)) {
				unlink($_SERVER['DOCUMENT_ROOT'].$gradientfilename);
			}
			if (file_exists($_SERVER['DOCUMENT_ROOT'].$maskfilename)) {
				unlink($_SERVER['DOCUMENT_ROOT'].$maskfilename);
			}
			// Return image data
			$imgdata = getimagesize($_SERVER['DOCUMENT_ROOT'].$filename);
			$width = $imgdata[0];
			$imageheight = $imgdata[1];
		
		}
		
		return array($filename, $imageheight);
		
	}	
	
	// Relative path
	function UnRealPath($place, $dest) {
		$Ahere = explode ('/', realpath($place));
		$Adest = explode ('/', realpath($dest));
		$result = '.'; 
		while (implode ('/', $Adest) != implode ('/', $Ahere))
		{
			if (count($Ahere)>count($Adest))
			{
				array_pop($Ahere);
				$result .= '/..';
			}
			else
			{
				array_pop($Adest);
			}
		}
		return str_replace('//', '/', $result.str_replace(implode ('/', $Adest), '', realpath($dest)).(@is_dir(realpath($dest))?'/':''));
	}
	
	// Convert to title case
	function titleCase($title) { 
		// List of words that we do not want in title case
		$smallwordsarray = array( 'of','a','the','and','an','or','nor','but','is','if','then','else','when', 'at','from','by','on','off','for','in','out','over','to','into','with' ); 
		$words = explode(' ', $title); 
		foreach ($words as $key => $word) { 
			if ($key == 0 or !in_array($word, $smallwordsarray)) $words[$key] = ucwords($word); 
		} 
		$newtitle = implode(' ', $words); 
		return $newtitle; 
	}

	// Global function that parses the text every time
	function doTheThing($string) {
		if (empty($string)) {
			$string = 'No input text given';
		} else {
			$string = mb_convert_encoding($string, 'UTF-8');
		  	$string = html_entity_decode($string, ENT_QUOTES,'UTF-8');
			$string = str_ireplace(array("", "", ""), array("'", "'", "-"), $string);
		}
	   	return $string;
	}
	
	// Convert a Hex colour value to an RGB colour value
	function hex2rgb($color) {
        $color = str_replace('#','',$color);
        $s = strlen($color) / 3;
        $rgb[] = hexdec(str_repeat(substr($color,0,$s),2/$s));
        $rgb[] = hexdec(str_repeat(substr($color,$s,$s),2/$s));
        $rgb[] = hexdec(str_repeat(substr($color,2*$s,$s),2/$s));
        return $rgb;
    }
	
	// UTF8 to ASCII
	function utf2ascii($string) {
		$iso88591  = "\\xE0\\xE1\\xE2\\xE3\\xE4\\xE5\\xE6\\xE7";
		$iso88591 .= "\\xE8\\xE9\\xEA\\xEB\\xEC\\xED\\xEE\\xEF";
		$iso88591 .= "\\xF0\\xF1\\xF2\\xF3\\xF4\\xF5\\xF6\\xF7";
		$iso88591 .= "\\xF8\\xF9\\xFA\\xFB\\xFC\\xFD\\xFE\\xFF";
		$ascii = "aaaaaaaceeeeiiiidnooooooouuuuyyy";
		return strtr(mb_strtolower(utf8_decode($string), 'ISO-8859-1'),$iso88591,$ascii);
	}

	// Replace Global Variables
	function replace_global_variables($text) {
		
		$replacer = new Global_variable_replacer();

		foreach($replacer->globals_lookup as $key => $value) {
				preg_match_all("/{$key}/", $text, $matches);

				if(sizeof($matches[0]) > 0) {
						$text = str_replace("{".$key."}", $value, $text);
				}
		}
		
		return $text;
		
	}
    
}





// Additional class for the Font Image Generator 2 tools 
class DefaultFontImagePluggableSet
	extends GMIPluggableSet
{
	
	function DefaultFontImagePluggableSet() {
		parent::GMIPluggableSet();
	}
	
	function getExpression() {
		
		$vars = $this->getVariables();
		
		if (isset($vars['exec'])) {
			return $vars['exec'];
		}
		
		// text drawing
		if ($vars['text'] !== null && $vars['font'] !== null && $vars['size'] !== null) {
			$font = "font {font:{font},{size},{leading}};";
		
			if ($vars['width'] !== null && $vars['height'] !== null) {
				$string = "string {text}, 0,0,{width},{height},{align},{valign};";
				$autoResize = "autoresize width;";
			}
			else if ($vars['width'] !== null) {
				$string = "string {text},0,0,{width},{align};";
				$autoResize = "autoresize both;";
			}
			else {
				$string = "string {text},0,0,{align};";
				$autoResize = "autoresize both;";
			}
		}
		else {
			$font = "";
			$string = "";
		}
		
		// background image drawing
		if ($vars['bgimage'] !== null) {
			$pattern = "pattern {image:{bgimage}};";
		}
		else {
			$pattern = "";
		}
		
		// foreground color
		if (preg_match('/^\s*\{\s*\w+\:.*\}\s*$/', $vars['color'])) {
			$foreground = "color {color};";
		}
		else {
			$foreground = "color {color:{color},{alpha}};";
		}
		
		// background color
		if (preg_match('/^\s*\{\s*\w+\:.*\}\s*$/', $vars['bgcolor'])) {
			$background = "color {bgcolor};";
		}
		else {
			$background = "color {color:{bgcolor}};";
		}
		
		// image type selection
		switch ($vars['type']) {
			case "jpeg":
				$type = "type {type},{quality};";
				break;
		
		
			case "png":
				if ($vars['palette'] === null) {
					$type = "type {type};";
					
					if ($vars['blank']) {
						$type .= "$background blank;";
					}
				}
				else {
					if ($vars['bgtrans'] == 'false') {
						$type = "type {type},{palette};";
					}
					else {
						$type = "type {type},{palette},{color:{bgcolor}};";
					}
				}
				break;
			
			case "gif":
			default:
				if ($vars['palette'] === null) {
					$vars['palette'] = 255;
				}
				if ($vars['bgtrans'] == 'false') {
					$type = "type {type},{palette};";
				}
				else {
					$type = "type {type},{palette},{color:{bgcolor}};";
				}
		}
		
		// file output
		if ($vars['file'] !== null) {
			$file = "file {file};";
		}
		else {
			$file = "";
		}
				
		return "size {width},{height}; $autoResize $type $file padding {padding}; $background fill; $pattern $foreground antialias {antialias}; $font $string";
	}
	
	function getVariables() {
		return array_merge($this->defaultVariables, $_GET);
	}
	
}

// Global Variable Replacer
class Global_variable_replacer
{
        var $globals_lookup = array();

        function Global_variable_replacer($site_id='')
        {
                $this->initGlobalsLookup($site_id);
        }
                
        /**
         *
         * Read in all the global variables from exp_global_variables and create a key/value lookup table
         */
        function initGlobalsLookup($site_id='')
        {
                global $DB, $PREFS;

                $site_id = (empty($site_id) ? $PREFS->core_ini['site_id'] : $site_id);

                $sql = "SELECT * FROM exp_global_variables";            
                if (!empty($site_id))
                {
                        $sql .= " WHERE site_id='".$site_id."'";
                }
                        $sql .= " ORDER BY variable_name ASC";
                
                $query = $DB->query($sql);
                
                if($query->num_rows > 0)
                {
                        foreach($query->result as $row) 
                {
                                $key = $row['variable_name'];
                                $value = $row['variable_data'];
                                $this->globals_lookup[$key] = $value;
                        }
                }
        }
        
        function getReplacedText($text)
        {
                $replacedText = $text;
        
                // if passed text in contains anything that looks like an EE variable, check in the DB global variables for it
                preg_match_all("/{([^}]+)}/", $text, $matches);
                
                $vars = $matches[1];
                
                if (sizeof($vars) > 0)
                {
                        foreach ($vars as $key)
                        {               
                                $global_value = $this->globals_lookup[$key];
//                              print("key: $key value: $global_value<br/>");//TMP
                                if ($global_value)
                                {
                                        $replacedText = str_replace("{".$key."}", $global_value, $replacedText);
                                }
                        }
                }
                
                return $replacedText;
        }

} // end class


?>